package cz.upol.zp4jv.lecture01;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import javax.xml.stream.XMLInputFactory;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamReader;


public class StAXExampleR {

	public static void main(String[] args) throws XMLStreamException {
		InputStream input = new ByteArrayInputStream("<?xml version=\"1.0\" encoding=\"UTF-8\"?><root><foo>Lorem ipsum</foo><foo bar=\"qux\"/></root>".getBytes());

		//nachystání parseru
		XMLInputFactory xmlInputFactory = XMLInputFactory.newInstance();
		XMLStreamReader reader = xmlInputFactory.createXMLStreamReader(input);
		
		int level = 0;

		//parsování samotné je řízeno ručně - tedy nereagujeme na událostí, ale vyvoláváme si je sami
		boolean done = false;
		while (!done) {
			switch (reader.getEventType()) { //jaká událost nás teď čeká?
			case XMLStreamReader.START_ELEMENT:  //otevírací tag
				padding(level++);
				System.out.println("Precten element: " + reader.getName());
				break;
				
			case XMLStreamReader.END_ELEMENT:  //uzavírací tag
				padding(--level);
				System.out.println("Konec elementu: " + reader.getName());
				break;
			
			case XMLStreamReader.CHARACTERS:  //textový obsah
				padding(level);
				System.out.println("Text: " + reader.getText());
				break;
				
			default:
				break;
			}
			if (reader.hasNext()) reader.next(); //pokud existuje další událost, sem s ní...
			else done = true;  //jinak končíme
		}

	}
	
	private static void padding(int level) {
		for (int i = 0; i < level; i++)
			System.out.print("   ");
	}

}